#include <conio.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

typedef unsigned char  byte;
typedef unsigned short word;



struct bitmap_header
{
   word type;
   word lof;
   word lof2;
   word x_hot;
   word y_hot;
   word first_pixel;
   word first_pixel2;
   word header_size;
   word header_size2;
   word x_size;             
   word x_size2;
   word y_size;
   word y_size2;
   word target;
   word bits_per_pixel;      

   word compression_method;
   word compression_method2;
   word compressed_size;
   word compressed_size2;
   word x_res;              
   word x_res2;
   word y_res;
   word y_res2;
   word used_clrs;
   word used_clrs2;         
   word important_clrs;
   word important_clrs2; //54 bytes
}bmfh;

struct targa_header
{
   int shite;
   int shit1;
   int shit2;
   word xs;
   word ys;
   byte bpp;
   byte magic;
}tgah;

byte * px;
int ix,iy;



int load_tga24(char *fname)
{
   FILE *input;
   int i;
   input=fopen(fname,"rb");
   if(input)
   {
      fread(&tgah,18,1,input);
      if(tgah.bpp==24)
      {
         ix=tgah.xs;
         iy=tgah.ys;
         px=(byte*)malloc(tgah.xs*tgah.ys*tgah.bpp/8);
         for (i=(tgah.ys-1);i>-1;i--)
         {
            fread(px+(3*i*tgah.xs),sizeof (byte),(tgah.xs)*3,input);
         }
         fclose(input);
         return 1;
      }
      fclose(input);
   }
   return 0;
}



void save_tga24(char *fname)
{
    int i;
    FILE *output;
    tgah.shite=0x00020000;
    tgah.shit1=0x00000000;
    tgah.shit2=0x00000000;
    tgah.xs=ix;
    tgah.ys=iy;
    tgah.bpp=24;
    tgah.magic=0;
    output=fopen(fname,"w+b");
    fwrite(&tgah,18,1,output);
    for (i=(tgah.ys-1);i>-1;i--)
    {
        fwrite(px+(3*i*tgah.xs),sizeof (byte),(tgah.xs)*3,output);
    }
    fclose(output);
}



int load_bmp24(char *fname)
{
   FILE *input;
   int i;
   input=fopen(fname,"rb");
   if (input)
   {
      fread(&bmfh,54,1,input);
      if (bmfh.bits_per_pixel==24)
      {
         ix=bmfh.x_size;
         iy=bmfh.y_size;
         px=(byte *)malloc(3*bmfh.x_size*bmfh.y_size);
         for (i=(bmfh.y_size-1);i>-1;i--)
         {
            fread(px+(3*i*bmfh.x_size),sizeof (byte),(bmfh.x_size)*3,input);
         }
         fclose(input);
         return 1;
      }
      fclose(input);
   }
   return 0;
}



void save_hgt(char *fname,char h_mod)
{
   int x,y;
   int pos;                      //pos in bmp ie sp[1].d[pos]
   int basepos;                  //base of chunk
   char xsegs,ysegs;             //total chunks in map
   signed char xseg,yseg;        //current chunk
   word h;                       //two byte height value valid range 0-4094
   byte lo_h,hi_h;               //the indi height bytes

   FILE *output;
   output=fopen(fname,"w+b");
   xsegs=ix/128;                 //hgt maps are divided into chunks of 128x128
   ysegs=iy/128;
   printf("\n %d chunks(s) detected...\n Creating chunk ",xsegs*ysegs);


   for (yseg=(ysegs-1);yseg>-1;yseg--)                   //read em left to right, bottom to top 
   {
      for (xseg=0;xseg<xsegs;xseg++)
      {
         basepos =(xseg*128*3)+(yseg*128*128*xsegs*3);
         printf("#");
         for (y=127;y>-1;y--)                            // also read left to right, bottom to top 
         {
            for (x=0;x<128;x++)
            {
               pos=((y*ix)+x)*3+basepos;                 //set the pos to read from 
               if (h_mod==0)
			   {
				   //bitshifted madness mode
					hi_h= ( px[pos+1] & 240 ) >> 4;
					lo_h= (( px[pos+1] & 15 ) << 4 ) + ( px[pos+2] & 15 );
			   }
			   else
			   {
				  //normal 'greyscale' mode'
                  h=h_mod*(px[pos]+px[pos+1]+px[pos+2]);    
                  lo_h=h&255;                               
                  hi_h=h>>8;
			   }
               putc(lo_h,output);                        
               putc(hi_h,output);
            }
         }
      }
   }
   fclose(output);
   printf("\n File %s created sucessfully!", fname);
}



int select(int min, int max)
{
	int k = getch()-48;
    if (k >= min && k<= max)
    {
		return k;
    }
    else
    {
         printf("\n invalid selection.. defaulting to option 1\n");
         return 1;
    }
}



int load_hgt(char *fname)
{
   int x, y;
   int pos;                     
   int basepos;                
   int segs =-1;
   int xsegs,ysegs;       
   signed char xseg,yseg;
   byte lo_h,hi_h;               


   FILE *input;
	px=(byte*)malloc(2*128*128);
   input=fopen(fname,"rb");
   while (!feof( input))
   {
		fread( px,2,128*128,input);
		segs++;
   }
	printf("\n%i blocks detected\n", segs);
	switch (segs)
	{
	case 1:
		xsegs=1;
		ysegs=1;
		break;
	case 2:
		printf("\n Please select\n");
		printf("\n 1: 256 x 128");
		printf("\n 2: 128 x 256");
		ysegs=select(1,2);
		xsegs=3-ysegs;
		break;
	case 3:
		printf("\n Please select\n");
		printf("\n 1: 384 x 128");
		printf("\n 2: 128 x 384");
		ysegs=select(1,2);
		if (ysegs==2)ysegs=3;
		xsegs=4-ysegs;
		break;
	case 4:
		printf("\n Please select\n");
		printf("\n 1: 512 x 128");
		printf("\n 2: 256 x 256");
		printf("\n 3: 128 x 512");
		ysegs=select(1,3);
		if (ysegs==3)ysegs=4;
		xsegs=4/ysegs;
		break;
	case 6:
		printf("\n Please select\n");
		printf("\n 1: 384 x 256");
		printf("\n 2: 256 x 384");
		ysegs=select(1,2)+1;
		xsegs=5-ysegs;
		break;
	case 8:
		printf("\n Please select\n");
		printf("\n 1: 512 x 256");
		printf("\n 2: 256 x 512");
		ysegs=select(1,2)*2;
		xsegs=6-ysegs;
		break;
	case 9:
		xsegs=3;
		ysegs=3;
		break;
	case 12:
		printf("\n Please select\n");
		printf("\n 1: 512 x 384");
		printf("\n 2: 384 x 512");
		ysegs=select(1,2)+2;
		xsegs=7-ysegs;
	case 16:
		xsegs=4;
		ysegs=4;
		break;
	default:
		printf("\n Unable to process file\n");
		return 0;
		break;
	}
	printf("processing %i x %i blocks",xsegs,ysegs);

	ix=xsegs*128;
	iy=ysegs*128;

	free(px);
	px=malloc(128*128*segs*3);
	fseek(input,0,SEEK_SET);
   for (yseg=(ysegs-1);yseg>-1;yseg--)                   
   {
      for (xseg=0;xseg<xsegs;xseg++)
      {
         basepos =(3*xseg*128)+(3*yseg*128*128*xsegs);
         printf("#");
	    for (y=127;y>-1;y--)                            // also read left to right, bottom to top 
		{
           for (x=0;x<128;x++)
		   {
              pos=((y*ix)+x)*3+basepos; 
              lo_h=getc(input);
              hi_h=getc(input);                        //write the chars straight out to file
		      px[pos]= 0;
		      px[pos+1]=((hi_h & 15)<<4) + ((lo_h & 240)>>4);
		      px[pos+2]=(lo_h&15);
		   }
		}
	  }
   }
   fclose(input);
   return 1;
}



void die()
{
	printf("\n\n Any key to exit\n");
	getch();
	exit(0);
}



int main(int argc, char*argv[])
{
   char k,h_mod;
   char ok=0;
   char *fname; 
   char *output;

   printf("\n HGT Convertor for BattleZone map makers\n");

   if (argc==1)
   {
      fname = "hgtmap.bmp";
   }
   else
   {
      fname = argv[1];
   }

   output = strlwr(strdup(fname));

   if (strstr(strlwr(fname),".hgt"))
   {
      load_hgt(fname);
	  strcpy(strstr(output,".hgt"),".tga");
	  save_tga24(output);
	  die();
   }
   if (strstr(strlwr(fname),".bmp"))
   {
      ok=load_bmp24(fname);
      strcpy(strstr(output,".bmp"),".hgt");
   }
   if (strstr(strlwr(fname),".tga"))
   {
      ok=load_tga24(fname);
      strcpy(strstr(output,".tga"),".hgt");
   }
      if(ok)
   {
      printf("\n %s found and loaded", fname);
      printf("\n\n Select Height Modifier: 1(flat) - 5(high)\n");
      printf(" Or 0 for precision colour mode.\n");
      k = select(0,6);
      printf("\n %d selected",k);
      h_mod=k;
      save_hgt(output,h_mod);
	  die();
   }
   else
   {
      printf("\nError: could not load file.");
      die();
   }
}

